unchanged:
Index: icedtea6-1.8.1/openjdk/hotspot/src/cpu/zero/vm/cppInterpreter_zero.cpp
===================================================================
--- icedtea6-1.8.1.orig/openjdk/hotspot/src/cpu/zero/vm/cppInterpreter_zero.cpp
+++ icedtea6-1.8.1/openjdk/hotspot/src/cpu/zero/vm/cppInterpreter_zero.cpp
@@ -935,6 +935,7 @@ void BytecodeInterpreter::layout_interpr
 
 address CppInterpreter::return_entry(TosState state, int length) {
   ShouldNotCallThis();
+  return NULL; // make gcc happy
 }
 
 address CppInterpreter::deopt_entry(TosState state, int length) {
@@ -955,6 +956,7 @@ bool CppInterpreter::contains(address pc
 #else
   return false; // make frame::print_value_on work
 #endif // !PRODUCT
+  return false; //make gcc happy
 }
 
 // Result handlers and convertors
Index: icedtea6-1.8.1/openjdk/hotspot/src/cpu/zero/vm/frame_zero.cpp
===================================================================
--- icedtea6-1.8.1.orig/openjdk/hotspot/src/cpu/zero/vm/frame_zero.cpp
+++ icedtea6-1.8.1/openjdk/hotspot/src/cpu/zero/vm/frame_zero.cpp
@@ -88,6 +88,7 @@ void frame::patch_pc(Thread* thread, add
 
 bool frame::safe_for_sender(JavaThread *thread) {
   ShouldNotCallThis();
+  return false; // make gcc happy
 }
 
 void frame::pd_gc_epilog() {
@@ -95,6 +96,7 @@ void frame::pd_gc_epilog() {
 
 bool frame::is_interpreted_frame_valid(JavaThread *thread) const {
   ShouldNotCallThis();
+  return false; // make gcc happy
 }
 
 BasicType frame::interpreter_frame_result(oop* oop_result,
@@ -159,6 +161,7 @@ int frame::frame_size() const {
 #else
   return 0; // make javaVFrame::print_value work
 #endif // PRODUCT
+  return 0; // make gcc happy
 }
 
 intptr_t* frame::interpreter_frame_tos_at(jint offset) const {
Index: icedtea6-1.8.1/openjdk/hotspot/src/cpu/zero/vm/frame_zero.inline.hpp
===================================================================
--- icedtea6-1.8.1.orig/openjdk/hotspot/src/cpu/zero/vm/frame_zero.inline.hpp
+++ icedtea6-1.8.1/openjdk/hotspot/src/cpu/zero/vm/frame_zero.inline.hpp
@@ -71,6 +71,7 @@ inline intptr_t* frame::sender_sp() cons
 
 inline intptr_t* frame::link() const {
   ShouldNotCallThis();
+  return NULL; // make gcc happy
 }
 
 #ifdef CC_INTERP
@@ -133,14 +134,17 @@ inline void frame::set_saved_oop_result(
 
 inline oop frame::saved_oop_result(RegisterMap* map) const {
   ShouldNotCallThis();
+  return NULL; // make gcc happy
 }
 
 inline bool frame::is_older(intptr_t* id) const {
   ShouldNotCallThis();
+  return false; // make gcc happy
 }
 
 inline intptr_t* frame::entry_frame_argument_at(int offset) const {
   ShouldNotCallThis();
+  return NULL; // make gcc happy
 }
 
 inline intptr_t* frame::unextended_sp() const {
Index: icedtea6-1.8.1/openjdk/hotspot/src/cpu/zero/vm/icBuffer_zero.cpp
===================================================================
--- icedtea6-1.8.1.orig/openjdk/hotspot/src/cpu/zero/vm/icBuffer_zero.cpp
+++ icedtea6-1.8.1/openjdk/hotspot/src/cpu/zero/vm/icBuffer_zero.cpp
@@ -41,9 +41,11 @@ void InlineCacheBuffer::assemble_ic_buff
 address InlineCacheBuffer::ic_buffer_entry_point(address code_begin) {
   // NB ic_stub_code_size() must return the size of the code we generate
   ShouldNotCallThis();
+  return NULL; // make gcc happy
 }
 
 oop InlineCacheBuffer::ic_buffer_cached_oop(address code_begin) {
   // NB ic_stub_code_size() must return the size of the code we generate
   ShouldNotCallThis();
+  return NULL; // make gcc happy
 }
Index: icedtea6-1.8.1/openjdk/hotspot/src/cpu/zero/vm/interpreter_zero.cpp
===================================================================
--- icedtea6-1.8.1.orig/openjdk/hotspot/src/cpu/zero/vm/interpreter_zero.cpp
+++ icedtea6-1.8.1/openjdk/hotspot/src/cpu/zero/vm/interpreter_zero.cpp
@@ -37,10 +37,12 @@ address InterpreterGenerator::generate_m
     return NULL;
 
   Unimplemented();
+  return NULL;
 }
 
 address InterpreterGenerator::generate_abstract_entry() {
   return ShouldNotCallThisEntry();
+  return NULL;
 }
 
 int AbstractInterpreter::size_activation(methodOop method,
Index: icedtea6-1.8.1/openjdk/hotspot/src/cpu/zero/vm/nativeInst_zero.hpp
===================================================================
--- icedtea6-1.8.1.orig/openjdk/hotspot/src/cpu/zero/vm/nativeInst_zero.hpp
+++ icedtea6-1.8.1/openjdk/hotspot/src/cpu/zero/vm/nativeInst_zero.hpp
@@ -42,15 +42,18 @@ class NativeInstruction VALUE_OBJ_CLASS_
  public:
   bool is_jump() {
     ShouldNotCallThis();
+    return false; // make gcc happy
   }
 
   bool is_safepoint_poll() {
     ShouldNotCallThis();
+    return false; // make gcc happy
   }
 };
 
 inline NativeInstruction* nativeInstruction_at(address address) {
   ShouldNotCallThis();
+  return NULL; // make gcc happy
 }
 
 class NativeCall : public NativeInstruction {
@@ -61,18 +64,22 @@ class NativeCall : public NativeInstruct
 
   address instruction_address() const {
     ShouldNotCallThis();
+    return NULL; // make gcc happy
   }
 
   address next_instruction_address() const {
     ShouldNotCallThis();
+    return NULL; // make gcc happy
   }
 
   address return_address() const {
     ShouldNotCallThis();
+    return NULL; // make gcc happy
   }
 
   address destination() const {
     ShouldNotCallThis();
+    return NULL; // make gcc happy
   }
 
   void set_destination_mt_safe(address dest) {
@@ -89,25 +96,30 @@ class NativeCall : public NativeInstruct
 
   static bool is_call_before(address return_address) {
     ShouldNotCallThis();
+    return false; // make gcc happy
   }
 };
 
 inline NativeCall* nativeCall_before(address return_address) {
   ShouldNotCallThis();
+  return NULL; // make gcc happy
 }
 
 inline NativeCall* nativeCall_at(address address) {
   ShouldNotCallThis();
+  return NULL; // make gcc happy
 }
 
 class NativeMovConstReg : public NativeInstruction {
  public:
   address next_instruction_address() const {
     ShouldNotCallThis();
+    return NULL; // make gcc happy
   }
 
   intptr_t data() const {
     ShouldNotCallThis();
+    return NULL; // make gcc happy
   }
 
   void set_data(intptr_t x) {
@@ -117,12 +129,14 @@ class NativeMovConstReg : public NativeI
 
 inline NativeMovConstReg* nativeMovConstReg_at(address address) {
   ShouldNotCallThis();
+  return NULL; // make gcc happy
 }
 
 class NativeMovRegMem : public NativeInstruction {
  public:
   int offset() const {
     ShouldNotCallThis();
+    return 0; // make gcc happy
   }
 
   void set_offset(intptr_t x) {
@@ -136,6 +150,7 @@ class NativeMovRegMem : public NativeIns
 
 inline NativeMovRegMem* nativeMovRegMem_at(address address) {
   ShouldNotCallThis();
+  return NULL; // make gcc happy
 }
 
 class NativeJump : public NativeInstruction {
@@ -146,6 +161,7 @@ class NativeJump : public NativeInstruct
 
   address jump_destination() const {
     ShouldNotCallThis();
+    return NULL; // make gcc happy
   }
 
   void set_jump_destination(address dest) {
@@ -163,12 +179,14 @@ class NativeJump : public NativeInstruct
 
 inline NativeJump* nativeJump_at(address address) {
   ShouldNotCallThis();
+  return NULL; // make gcc happy
 }
 
 class NativeGeneralJump : public NativeInstruction {
  public:
   address jump_destination() const {
     ShouldNotCallThis();
+    return NULL; // make gcc happy
   }
 
   static void insert_unconditional(address code_pos, address entry) {
@@ -182,4 +200,5 @@ class NativeGeneralJump : public NativeI
 
 inline NativeGeneralJump* nativeGeneralJump_at(address address) {
   ShouldNotCallThis();
+  return NULL; // make gcc happy
 }
Index: icedtea6-1.8.1/openjdk/hotspot/src/cpu/zero/vm/register_zero.cpp
===================================================================
--- icedtea6-1.8.1.orig/openjdk/hotspot/src/cpu/zero/vm/register_zero.cpp
+++ icedtea6-1.8.1/openjdk/hotspot/src/cpu/zero/vm/register_zero.cpp
@@ -32,8 +32,10 @@ const int ConcreteRegisterImpl::max_fpr
 
 const char* RegisterImpl::name() const {
   ShouldNotCallThis();
+  return ""; // make gcc happy
 }
 
 const char* FloatRegisterImpl::name() const {
   ShouldNotCallThis();
+  return ""; // make gcc happy
 }
Index: icedtea6-1.8.1/openjdk/hotspot/src/cpu/zero/vm/relocInfo_zero.cpp
===================================================================
--- icedtea6-1.8.1.orig/openjdk/hotspot/src/cpu/zero/vm/relocInfo_zero.cpp
+++ icedtea6-1.8.1/openjdk/hotspot/src/cpu/zero/vm/relocInfo_zero.cpp
@@ -32,6 +32,7 @@ void Relocation::pd_set_data_value(addre
 
 address Relocation::pd_call_destination(address orig_addr) {
   ShouldNotCallThis();
+  return NULL; // make gcc happy
 }
 
 void Relocation::pd_set_call_destination(address x) {
@@ -40,6 +41,7 @@ void Relocation::pd_set_call_destination
 
 address Relocation::pd_get_address_from_code() {
   ShouldNotCallThis();
+  return NULL; // make gcc happy
 }
 
 address* Relocation::pd_address_in_code() {
@@ -49,6 +51,7 @@ address* Relocation::pd_address_in_code(
 
 int Relocation::pd_breakpoint_size() {
   ShouldNotCallThis();
+  return 0; // make gcc happy
 }
 
 void Relocation::pd_swap_in_breakpoint(address x,
Index: icedtea6-1.8.1/openjdk/hotspot/src/cpu/zero/vm/sharedRuntime_zero.cpp
===================================================================
--- icedtea6-1.8.1.orig/openjdk/hotspot/src/cpu/zero/vm/sharedRuntime_zero.cpp
+++ icedtea6-1.8.1/openjdk/hotspot/src/cpu/zero/vm/sharedRuntime_zero.cpp
@@ -69,6 +69,7 @@ nmethod *SharedRuntime::generate_native_
 #else
   ShouldNotCallThis();
 #endif // SHARK
+  return NULL; // make gcc happy
 }
 
 int Deoptimization::last_frame_adjust(int callee_parameters,
@@ -78,6 +79,7 @@ int Deoptimization::last_frame_adjust(in
 
 uint SharedRuntime::out_preserve_stack_slots() {
   ShouldNotCallThis();
+  return 0; // make gcc happy
 }
 
 static RuntimeStub* generate_empty_runtime_stub(const char* name) {
@@ -112,4 +114,5 @@ int SharedRuntime::c_calling_convention(
                                          VMRegPair *regs,
                                          int total_args_passed) {
   ShouldNotCallThis();
+  return 0; // make gcc happy
 }
Index: icedtea6-1.8.1/openjdk/hotspot/src/cpu/zero/vm/vtableStubs_zero.cpp
===================================================================
--- icedtea6-1.8.1.orig/openjdk/hotspot/src/cpu/zero/vm/vtableStubs_zero.cpp
+++ icedtea6-1.8.1/openjdk/hotspot/src/cpu/zero/vm/vtableStubs_zero.cpp
@@ -28,16 +28,20 @@
 
 VtableStub* VtableStubs::create_vtable_stub(int vtable_index) {
   ShouldNotCallThis();
+  return NULL; // make gcc happy
 }
 
 VtableStub* VtableStubs::create_itable_stub(int vtable_index) {
   ShouldNotCallThis();
+  return NULL; // make gcc happy
 }
 
 int VtableStub::pd_code_size_limit(bool is_vtable_stub) {
   ShouldNotCallThis();
+  return 0; // make gcc happy
 }
 
 int VtableStub::pd_code_alignment() {
   ShouldNotCallThis();
+  return 0; // make gcc happy
 }
Index: icedtea6-1.8.1/openjdk/hotspot/src/os_cpu/linux_zero/vm/os_linux_zero.cpp
===================================================================
--- icedtea6-1.8.1.orig/openjdk/hotspot/src/os_cpu/linux_zero/vm/os_linux_zero.cpp
+++ icedtea6-1.8.1/openjdk/hotspot/src/os_cpu/linux_zero/vm/os_linux_zero.cpp
@@ -33,6 +33,7 @@ address os::current_stack_pointer() {
 
 frame os::get_sender_for_C_frame(frame* fr) {
   ShouldNotCallThis();
+  return *fr; // make gcc happy
 }
 
 frame os::current_frame() {
@@ -62,6 +63,7 @@ char* os::non_memory_address_word() {
   // This is the value for x86; works pretty well for PPC too.
   return (char *) -1;
 #endif // SPARC
+  return (char *) -1; // make gcc happy
 }
 
 void os::initialize_thread() {
@@ -70,16 +72,19 @@ void os::initialize_thread() {
 
 address os::Linux::ucontext_get_pc(ucontext_t* uc) {
   ShouldNotCallThis();
+  return NULL; // make gcc happy
 }
 
 ExtendedPC os::fetch_frame_from_context(void* ucVoid,
                                         intptr_t** ret_sp,
                                         intptr_t** ret_fp) {
   ShouldNotCallThis();
+  return NULL; // make gcc happy
 }
 
 frame os::fetch_frame_from_context(void* ucVoid) {
   ShouldNotCallThis();
+  return *(frame*)ucVoid; // make gcc happy
 }
 
 #ifdef HOTSPOT_ASM
@@ -242,6 +248,7 @@ void os::Linux::init_thread_fpu_state(vo
 
 int os::Linux::get_fpu_control_word() {
   ShouldNotCallThis();
+  return 0; // make gcc happy
 }
 
 void os::Linux::set_fpu_control_word(int fpu) {
@@ -264,6 +271,7 @@ bool os::is_allocatable(size_t bytes) {
 
   return addr != NULL;
 #endif // _LP64
+  return false; // make gcc happy
 }
 
 ///////////////////////////////////////////////////////////////////////////////
@@ -386,6 +394,7 @@ void os::print_context(outputStream* st,
 
 extern "C" {
   int SpinPause() {
+    return 0; // make gcc happy
   }
 
   int SafeFetch32(int *adr, int errValue) {
@@ -475,6 +484,7 @@ extern "C" {
     long long unsigned int oldval,
     long long unsigned int newval) {
     ShouldNotCallThis();
+    return 0; // make gcc happy
   }
 };
 #endif // !_LP64
Index: icedtea6-1.8.1/openjdk/hotspot/src/os_cpu/linux_zero/vm/thread_linux_zero.hpp
===================================================================
--- icedtea6-1.8.1.orig/openjdk/hotspot/src/os_cpu/linux_zero/vm/thread_linux_zero.hpp
+++ icedtea6-1.8.1/openjdk/hotspot/src/os_cpu/linux_zero/vm/thread_linux_zero.hpp
@@ -95,6 +95,7 @@
                                            void* ucontext,
                                            bool isInJava) {
     ShouldNotCallThis();
+    return false;
   }
 
   // These routines are only used on cpu architectures that
--- icedtea6-1.8.1.orig/openjdk/hotspot/src/cpu/zero/vm/methodHandles_zero.cpp	2012/01/25 13:21:54	1.1
+++ icedtea6-1.8.1/openjdk/hotspot/src/cpu/zero/vm/methodHandles_zero.cpp	2012/01/25 13:22:02
@@ -28,6 +28,7 @@
 
 int MethodHandles::adapter_conversion_ops_supported_mask() {
   ShouldNotCallThis();
+  return 0;
 }
 
 void MethodHandles::generate_method_handle_stub(MacroAssembler*          masm,
--- icedtea6-1.8.1.orig/openjdk/hotspot/src/cpu/zero/vm/assembler_zero.cpp	2012/02/01 23:57:44	1.1
+++ icedtea6-1.8.1/openjdk/hotspot/src/cpu/zero/vm/assembler_zero.cpp	2012/02/01 23:58:51
@@ -57,6 +57,7 @@
 RegisterOrConstant MacroAssembler::delayed_value_impl(
   intptr_t* delayed_value_addr, Register tmpl, int offset) {
   ShouldNotCallThis();
+  return RegisterOrConstant(tmpl);
 }
 
 void MacroAssembler::store_oop(jobject obj) {
--- icedtea6-1.8.1.orig/openjdk/hotspot/src/cpu/zero/vm/interp_masm_zero.hpp	2012/02/01 23:59:21	1.1
+++ icedtea6-1.8.1/openjdk/hotspot/src/cpu/zero/vm/interp_masm_zero.hpp	2012/02/01 23:59:38
@@ -34,5 +34,6 @@
                                         Register  tmp,
                                         int       offset) {
     ShouldNotCallThis();
+    return RegisterOrConstant(tmp);
   }
 };
